/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.model;
import android.content.ContentProviderOperation;//进行批量更新、删除、插入数据操作，效率更高
import android.content.ContentProviderResult;//操作结果
import android.content.ContentUris;//工具类，处理使用“content”约束的Uri对象 content Uri对象语法格式：content：//authority/path/id
import android.content.ContentValues;//存储一些名值对，当中名是一个String类型，值为基本类型
import android.content.Context;//直接继承java.lang.Object类。类似于接口：从该类继承或者从它的直接或间接子类继承，那么继承的子类就可以拿到应用程序的全局信息。
import android.content.OperationApplicationException;//操作应用程序容错
import android.net.Uri;//Uri代表要操作的数据，Android上可用的每种资源、图像、视频片段等都可以用Uri来表示。
import android.os.RemoteException;//远程容错
import android.util.Log;//工具类，打印日志与查看日志

import net.micode.notes.data.Notes;//导入data文件中的Notes包
import net.micode.notes.data.Notes.CallNote;//导入Notes的全局类（public static final class）CallNote
import net.micode.notes.data.Notes.DataColumns;//导入Notes中的DataColumns类
import net.micode.notes.data.Notes.NoteColumns;//导入Notes中的NoteColumns类
import net.micode.notes.data.Notes.TextNote;//导入Notes中的TextNode类

import java.util.ArrayList;//ArrayList 继承了 AbstractList ，并实现了 List 接口。是一个可以动态修改的数组，与普通数组的区别就是它是没有固定大小的限制，我们可以添加或删除元素。


public class Note {//全局变量，创建公共类note
    private ContentValues mNoteDiffValues;//private仅该类可随意访问mNoteDiffValues；ContentValues里可以put各种类型的数据
    private NoteData mNoteData;//用于存储便签内容的NoteData对象
    private static final String TAG = "Note";// 定义了一个日志标签
    /**
     * Create a new note id for adding a new note to databases
     */
    public static synchronized long getNewNoteId(Context context, long folderId) {// 创建一个新的便签到数据库
        // Create a new note in the database
        ContentValues values = new ContentValues();//数据库操作，可put各种类型数据， 初始化ContentValues对象
        long createdTime = System.currentTimeMillis();//获取当前的总毫秒数
        values.put(NoteColumns.CREATED_DATE, createdTime);// 设置便签的创建时间
        values.put(NoteColumns.MODIFIED_DATE, createdTime);// 设置便签的修改时间
        values.put(NoteColumns.TYPE, Notes.TYPE_NOTE); // 设置便签的类型
        values.put(NoteColumns.LOCAL_MODIFIED, 1);// 设置便签的本地修改状态
        values.put(NoteColumns.PARENT_ID, folderId);//将数据写入数据库表格，设置便签的父ID，即所属文件夹ID
        Uri uri = context.getContentResolver().insert(Notes.CONTENT_NOTE_URI, values);//ContentResolver（）主要实现外部应用对COntentProvider中的数据进行添加、删除、修改、和查询操作

        long noteId = 0;// 初始化便签ID
        try {
            noteId = Long.valueOf(uri.getPathSegments().get(1));//Long.valueOf(参数)将基本数据类型转换成包装类；get（1）：把Uri中以 / 作为分割，0部分是路径，1部分则是id。
        } catch (NumberFormatException e) {
            Log.e(TAG, "Get note id error :" + e.toString());// 异常处理，记录错误日志
            noteId = 0;// 如果转换出错，设置ID为0
        }//捕捉处理异常：NumberFormatException：无法将字符串转换为任何数字类型时引发异常。
        if (noteId == -1) {
            throw new IllegalStateException("Wrong note id:" + noteId);//如果ID为-1，抛出异常
        }//IllegalStateException是Java中的一个非受检异常，它表示在不适当的时间或状态下调用方法。
        return noteId;
    }

    public Note() {
        mNoteDiffValues = new ContentValues();
        mNoteData = new NoteData();
    }//定义变量存储便签数据：mNoteDiffValues存储便签属性  mNoteData存储便签内容

    public void setNoteValue(String key, String value) {
        mNoteDiffValues.put(key, value);// 向mNoteDiffValues中添加键值对
        mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);// 设置本地修改状态
        mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());// 更新修改时间
    }//设置数据库表格的标签属性数据

    public void setTextData(String key, String value) {
        mNoteData.setTextData(key, value);// 设置便签内容数据
    }//设置数据库表格的标签文本内容的数据

    public void setTextDataId(long id) {
        mNoteData.setTextDataId(id);
    }//文本数据ID

    public long getTextDataId() {
        return mNoteData.mTextDataId;
    }//获取文本数据ID

    public void setCallDataId(long id) {
        mNoteData.setCallDataId(id);
    }//set电话号码数据ID

    public void setCallData(String key, String value) {
        mNoteData.setCallData(key, value);
    }//获取电话号码数据ID

    public boolean isLocalModified() {
        return mNoteDiffValues.size() > 0 || mNoteData.isLocalModified();
    }//判断是否是本地修改

    public boolean syncNote(Context context, long noteId) {
        if (noteId <= 0) {
            throw new IllegalArgumentException("Wrong note id:" + noteId);// 检查便签ID是否合法
        }

        if (!isLocalModified()) {
            return true;// 如果没有本地修改，直接返回true
        }

        /**
         * In theory, once data changed, the note should be updated on {@link NoteColumns#LOCAL_MODIFIED} and
         * {@link NoteColumns#MODIFIED_DATE}. For data safety, though update note fails, we also update the
         * note data info
         */
        if (context.getContentResolver().update(
                ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), mNoteDiffValues, null,
                null) == 0) {
            Log.e(TAG, "Update note error, should not happen");// 如果更新失败，记录错误日志
            // Do not return, fall through
        }
        mNoteDiffValues.clear();// 清除mNoteDiffValues

        if (mNoteData.isLocalModified()// 如果便签数据有本地修改
                && (mNoteData.pushIntoContentResolver(context, noteId) == null)) {
            return false;// 如果更新便签数据失败，返回false
        }

        return true;// 如果所有更新都成功，返回true
    }//判断数据是否同步

    private class NoteData {//定义了一个私有的NoteData类，用于存储便签内容数据
        private long mTextDataId;

        private ContentValues mTextDataValues;//文本数据

        private long mCallDataId;

        private ContentValues mCallDataValues;//电话号码数据

        private static final String TAG = "NoteData";

        public NoteData() {
            mTextDataValues = new ContentValues();
            mCallDataValues = new ContentValues();// 在构造函数中初始化mTextDataValues和mCallDataValues
            mTextDataId = 0;
            mCallDataId = 0;// 初始化文本数据ID和通话数据ID
        }
        //函数的具体实现如下
        boolean isLocalModified() {
            return mTextDataValues.size() > 0 || mCallDataValues.size() > 0;// 判断是否有本地修改
        }

        void setTextDataId(long id) {
            if(id <= 0) {
                throw new IllegalArgumentException("Text data id should larger than 0");// 检查文本数据ID是否合法
            }
            mTextDataId = id;// 设置文本数据ID
        }

        void setCallDataId(long id) {
            if (id <= 0) {
                throw new IllegalArgumentException("Call data id should larger than 0");// 检查通话数据ID是否合法
            }
            mCallDataId = id;
        }

        void setCallData(String key, String value) {
            mCallDataValues.put(key, value);// 向mCallDataValues添加键值对
            mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);// 设置本地修改状态
            mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());// 更新修改时间
        }

        void setTextData(String key, String value) {
            mTextDataValues.put(key, value); // 向mTextDataValues添加键值对
            mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);// 设置本地修改状态
            mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());// 更新修改时间
        }
        //将新的数据通过uri的操作存储到数据库
        Uri pushIntoContentResolver(Context context, long noteId) {
            /**
             * Check for safety
             */
            if (noteId <= 0) {
                throw new IllegalArgumentException("Wrong note id:" + noteId);
            }//判断数据是否合法

            ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
            ContentProviderOperation.Builder builder = null;//数据库的操作列表

            if(mTextDataValues.size() > 0) {
                mTextDataValues.put(DataColumns.NOTE_ID, noteId);
                if (mTextDataId == 0) {
                    mTextDataValues.put(DataColumns.MIME_TYPE, TextNote.CONTENT_ITEM_TYPE);
                    Uri uri = context.getContentResolver().insert(Notes.CONTENT_DATA_URI,
                            mTextDataValues);
                    try {
                        setTextDataId(Long.valueOf(uri.getPathSegments().get(1)));
                    } catch (NumberFormatException e) {
                        Log.e(TAG, "Insert new text data fail with noteId" + noteId);
                        mTextDataValues.clear();
                        return null;
                    }
                } else {
                    builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mTextDataId));
                    builder.withValues(mTextDataValues);
                    operationList.add(builder.build());
                }
                mTextDataValues.clear();
            }//把文本数据存入DataColumns

            if(mCallDataValues.size() > 0) {
                mCallDataValues.put(DataColumns.NOTE_ID, noteId);
                if (mCallDataId == 0) {
                    mCallDataValues.put(DataColumns.MIME_TYPE, CallNote.CONTENT_ITEM_TYPE);
                    Uri uri = context.getContentResolver().insert(Notes.CONTENT_DATA_URI,
                            mCallDataValues);
                    try {
                        setCallDataId(Long.valueOf(uri.getPathSegments().get(1)));
                    } catch (NumberFormatException e) {
                        Log.e(TAG, "Insert new call data fail with noteId" + noteId);
                        mCallDataValues.clear();
                        return null;
                    }
                } else {
                    builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mCallDataId));
                    builder.withValues(mCallDataValues);
                    operationList.add(builder.build());
                }
                mCallDataValues.clear();
            }//把电话号码数据存入Datacolumns

            if (operationList.size() > 0) {
                try {
                    ContentProviderResult[] results = context.getContentResolver().applyBatch(
                            Notes.AUTHORITY, operationList);
                    return (results == null || results.length == 0 || results[0] == null) ? null
                            : ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId);
                } catch (RemoteException e) {
                    Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
                    return null;
                } catch (OperationApplicationException e) {
                    Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
                    return null;
                }
            }//存储过程中的异常处理
            return null;
        }
    }
}
